<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/linmove.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/linmove.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 PlaneShift Team (info@planeshift.it,</span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2001-2003 by Jorrit Tyberghein</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00008"></a>00008 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 <span class="comment"></span>
<a name="l00011"></a>00011 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">    Library General Public License for more details.</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00017"></a>00017 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00018"></a>00018 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00019"></a>00019 <span class="comment">*/</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">/*</span>
<a name="l00022"></a>00022 <span class="comment"> * This code is heavily based on pslinmove from the PlaneShift project.</span>
<a name="l00023"></a>00023 <span class="comment"> * Thanks a lot for making this!</span>
<a name="l00024"></a>00024 <span class="comment"> */</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifndef __CEL_PF_LINEAR_MOVE__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_LINEAR_MOVE__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/strhash_8h.html">csutil/strhash.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiDataBuffer.html">iDataBuffer</a>;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>;
<a name="l00036"></a>00036 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiPath.html">iPath</a>;
<a name="l00037"></a>00037 <span class="keyword">struct </span><a class="code" href="structiPcCollisionDetection.html" title="This property class controls collision detection of an entity with the world map and other meshes...">iPcCollisionDetection</a>;
<a name="l00038"></a>00038 <span class="keyword">struct </span><a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>;
<a name="l00039"></a>00039 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00050"></a><a class="code" href="structiPcGravityCallback.html">00050</a> <span class="keyword">struct </span><a class="code" href="structiPcGravityCallback.html" title="Inherit this class if you want to know when gravity is applied to a certain iPcLinearMovement.">iPcGravityCallback</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   SCF_INTERFACE (<a class="code" href="structiPcGravityCallback.html" title="Inherit this class if you want to know when gravity is applied to a certain iPcLinearMovement.">iPcGravityCallback</a>, 0, 0, 2);
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcGravityCallback.html#acd0eb0d6c680ac838411f600a1b26307" title="The gravity is applied on this frame on the iPcLinearMovementiPcLinearMovement of this entity...">Callback</a> () = 0;
<a name="l00059"></a>00059 };
<a name="l00060"></a>00060 
<a name="l00097"></a><a class="code" href="structiPcLinearMovement.html">00097</a> <span class="keyword">struct </span><a class="code" href="structiPcLinearMovement.html" title="This property class controls movement of an entity in a realistic manner.">iPcLinearMovement</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   SCF_INTERFACE (<a class="code" href="structiPcLinearMovement.html" title="This property class controls movement of an entity in a realistic manner.">iPcLinearMovement</a>, 0, 0, 3);
<a name="l00100"></a>00100 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a19692e09c4bb839549a8fadc1d671366" title="Set an anchor for this movement class.">SetAnchor</a> (<a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>* pcmesh) = 0;
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>* <a class="code" href="structiPcLinearMovement.html#a3127ba33866324151c029f986a21d905" title="Get the current anchor or 0 if movement is not anchored.">GetAnchor</a> () <span class="keyword">const</span> = 0;
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#abc0d6aa757b0bbeb122792bad05f4254" title="Set the orientation of the mesh with three given euler angles.">SetAngularVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; angle) = 0;
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#abc0d6aa757b0bbeb122792bad05f4254" title="Set the orientation of the mesh with three given euler angles.">SetAngularVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; angle,
<a name="l00124"></a>00124         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; angle_to_reach) = 0;
<a name="l00125"></a>00125 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a5d2b89b2f25fffa741900bc5b34e5a2c" title="Set the current speed.">SetSpeed</a> (<span class="keywordtype">float</span> speedZ) = 0;
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcLinearMovement.html#a3b9323649643e5883bc9cc4fa7ee5d0e" title="Get the current speed.">GetSpeed</a> () <span class="keyword">const</span> = 0;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use void SetBodyVelocity () instead.&quot;</span>)
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a5ee8d69c5959001a620761dcaddd6ec0" title="Set the current velocity vector in body coordinates.">SetVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel) = 0;
<a name="l00138"></a>00138 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#af00dca12bab8927e9b5eb1ee28538b0e" title="Set the current velocity vector in body coordinates.">SetBodyVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel) = 0;
<a name="l00143"></a>00143 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a610d6a6be827092ed3adca9d86534daa" title="Set the current world velocity vector in body coordinates.">SetWorldVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel) = 0;
<a name="l00148"></a>00148 
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a7f4455ea9bec08259033db47c0e4ac48" title="Exerts a velocity on the body in world coordinates.">AddVelocity</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel) = 0;
<a name="l00153"></a>00153 
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a91037fa284476c7f09dc56fd8c7f83e7" title="Resets the velocity of this body in world coordinates.">ClearWorldVelocity</a> () = 0;
<a name="l00156"></a>00156 
<a name="l00161"></a>00161   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use csVector3 GetVelocity () instead.&quot;</span>)
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a03d130f45937fa0992547124da7828e5" title="Get the current velocity vector in local coordinate space: WorldToObject(worldvel) + bodyvel...">GetVelocity</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v) <span class="keyword">const</span> = 0;
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;<a class="code" href="structiPcLinearMovement.html#aeab9ad6e19503da71505f6b4c20cdbed" title="Get the body&#39;s velocity- velocity minus physical effects like gravity.">GetBodyVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;<a class="code" href="structiPcLinearMovement.html#afe7973d4e25b2f4bf03efa0e99741820" title="Get the world&#39;s velocity- velocity for simulating physical effects like gravity.">GetWorldVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcLinearMovement.html#a03d130f45937fa0992547124da7828e5" title="Get the current velocity vector in local coordinate space: WorldToObject(worldvel) + bodyvel...">GetVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aac57682caae7fb4eb602f408a8db654c" title="Get the current angular velocity vector.">GetAngularVelocity</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v) <span class="keyword">const</span> = 0;
<a name="l00184"></a>00184 
<a name="l00193"></a>00193   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcLinearMovement.html#a385ad0f1d45d02e2f4497c3a901dd868" title="Initialize CD box for the object from a mesh.">InitCD</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a>* mesh, <span class="keywordtype">float</span> percentage,
<a name="l00194"></a>00194         <a class="code" href="structiPcCollisionDetection.html" title="This property class controls collision detection of an entity with the world map and other meshes...">iPcCollisionDetection</a>* pc_cd = 0) = 0;
<a name="l00195"></a>00195 
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcLinearMovement.html#a385ad0f1d45d02e2f4497c3a901dd868" title="Initialize CD box for the object from a mesh.">InitCD</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; body, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; legs,
<a name="l00205"></a>00205         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; shift, <a class="code" href="structiPcCollisionDetection.html" title="This property class controls collision detection of an entity with the world map and other meshes...">iPcCollisionDetection</a> *pc_cd = 0) = 0;
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a2a0510c3c6b80e6ff9bdc5ecfaf6ddad" title="Get CD box for the object.">GetCDDimensions</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; body, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; legs,
<a name="l00211"></a>00211         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; shift, <a class="code" href="structiPcCollisionDetection.html" title="This property class controls collision detection of an entity with the world map and other meshes...">iPcCollisionDetection</a>*&amp; pc_cd) = 0;
<a name="l00212"></a>00212 
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcLinearMovement.html#a385ad0f1d45d02e2f4497c3a901dd868" title="Initialize CD box for the object from a mesh.">InitCD</a> (<a class="code" href="structiPcCollisionDetection.html" title="This property class controls collision detection of an entity with the world map and other meshes...">iPcCollisionDetection</a> *pc_cd=0) = 0;
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="structiPcLinearMovement.html#a8a055fc1e2c0d083c05c9d21e11aae26" title="Returns the difference in time between now and when the last DR update or extrapolation took place...">TimeDiff</a> (<span class="keywordtype">void</span>) = 0;
<a name="l00223"></a>00223 
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a7fd0424179e33852fa873b6e3a4ae3eb" title="Return all necessary data for Dead Reckoning.">GetDRData</a> (<span class="keywordtype">bool</span>&amp; on_ground, <span class="keywordtype">float</span>&amp; speed, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos,
<a name="l00226"></a>00226         <span class="keywordtype">float</span>&amp; yrot, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>*&amp; sector, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; worldVel,
<a name="l00227"></a>00227         <span class="keywordtype">float</span>&amp; ang_vel) = 0;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00231"></a>00231   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ad144753dbf091089abfd47a2dc46109c" title="Sets all relevant dead reckoning data on this entity.">SetDRData</a> (<span class="keywordtype">bool</span> on_ground,<span class="keywordtype">float</span> speed, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos,
<a name="l00232"></a>00232         <span class="keywordtype">float</span> yrot, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; worldVel,
<a name="l00233"></a>00233         <span class="keywordtype">float</span> ang_vel) = 0;
<a name="l00234"></a>00234 
<a name="l00241"></a>00241   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a8e9b86a3512378b504b94269934edb1c" title="Sets dead reckoning data in a &#39;soft&#39; way.">SetSoftDRData</a> (<span class="keywordtype">bool</span> on_ground,<span class="keywordtype">float</span> speed, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos,
<a name="l00242"></a>00242         <span class="keywordtype">float</span> yrot,<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vel, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; worldVel,
<a name="l00243"></a>00243         <span class="keywordtype">float</span> ang_vel) = 0;
<a name="l00244"></a>00244 
<a name="l00249"></a>00249   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ac2e794bf145fbd5230bc731d0a3bc8e1" title="Set full position and sector.">SetFullPosition</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">float</span> yrot,
<a name="l00250"></a>00250         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00255"></a>00255   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aa665242aafa97f3204e4118595c93442" title="Set position and sector.">SetPosition</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">float</span> yrot,
<a name="l00256"></a>00256         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00262"></a>00262   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a88318839a7bb34215ae62e8512827972" title="Get position and sector.">GetLastPosition</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">float</span>&amp; yrot,
<a name="l00263"></a>00263         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>*&amp; sector) = 0;
<a name="l00268"></a>00268   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a2e269bc67e867d43a07afe03c0bebcd9" title="Get full position and sector.">GetLastFullPosition</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">float</span>&amp; yrot,
<a name="l00269"></a>00269         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>*&amp; sector) = 0;
<a name="l00270"></a>00270 
<a name="l00274"></a>00274   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcLinearMovement.html#a8d220e4d54e37df7cf4ec67e87af7148" title="Get Y Rotation.">GetYRotation</a> () = 0;
<a name="l00280"></a>00280   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcLinearMovement.html#a60e059d114067144f7c9cbdfdd14488f" title="Get position and sector.">GetPosition</a> () = 0;
<a name="l00285"></a>00285   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcLinearMovement.html#a52314153894bb2a243be5d1abd161a5b" title="Get full position.">GetFullPosition</a> () = 0;
<a name="l00286"></a>00286 
<a name="l00290"></a>00290   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a> <a class="code" href="structiPcLinearMovement.html#a156ddc0f717db1b6585b7ec58ab3da06" title="Get the full transform describing the world to this transform.">GetFullTransform</a> () = 0;
<a name="l00291"></a>00291 
<a name="l00293"></a>00293   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcLinearMovement.html#a73ec77995294b032f1238173f082689c" title="Is a csPath active now or standard DR movement?">IsPath</a> () <span class="keyword">const</span> = 0;
<a name="l00294"></a>00294 
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="code" href="structiPcLinearMovement.html#a43e7ab4c68db0f545ef3dd40a968b444" title="Get sector.">GetSector</a> () = 0;
<a name="l00299"></a>00299 
<a name="l00304"></a>00304   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a08ad2def333cd5425ff7f4123ada25f1" title="This function actually moves and rotates the mesh, relighting if necessary.">ExtrapolatePosition</a> (<span class="keywordtype">float</span> delta) = 0;
<a name="l00305"></a>00305 
<a name="l00312"></a>00312   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a5b2cc551ac4e34d99be35274d9fffefb" title="This function calls ExtrapolatePosition with a certain time but uses a fixed delta.">UpdateDRDelta</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> ticksdelta) = 0;
<a name="l00313"></a>00313 
<a name="l00321"></a>00321   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aeb8b4e42a7eddca820afa7c73a8806f2" title="This function calls ExtrapolatePosition with by calculating the delta from now relative to the last u...">UpdateDR</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> ticks) = 0;
<a name="l00322"></a>00322 
<a name="l00330"></a>00330   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aeb8b4e42a7eddca820afa7c73a8806f2" title="This function calls ExtrapolatePosition with by calculating the delta from now relative to the last u...">UpdateDR</a> () = 0;
<a name="l00331"></a>00331 
<a name="l00337"></a>00337   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a6f568b2fd4d19f261af885a076bf0995" title="This function lets linmove store a ref to the supplied iPath.">SetPath</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiPath.html">iPath</a> *newpath) = 0;
<a name="l00338"></a>00338 
<a name="l00343"></a>00343   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a05c5ee10d53720176bb591f1a910c6bb" title="This function sets the current position on the path for use when time deltas are added later...">SetPathTime</a> (<span class="keywordtype">float</span> timeval) = 0;
<a name="l00344"></a>00344 
<a name="l00352"></a>00352   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a503edf85cf3f8e020da21cd5bcff9abd" title="This relates the movement of the entity along the path to the time values specified by the path...">SetPathSpeed</a> (<span class="keywordtype">float</span> speed) = 0;
<a name="l00353"></a>00353 
<a name="l00362"></a>00362   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ad253b78fb9cc3041ff73faa1aa80115e" title="This relates a particular action name to be used between two points in the path.">SetPathAction</a> (<span class="keywordtype">int</span> which, <span class="keyword">const</span> <span class="keywordtype">char</span> *action) = 0;
<a name="l00363"></a>00363 
<a name="l00368"></a>00368   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ad9857e6ae7fd065734b93eedf7982ca1" title="This sets the sector which will be used for the entire path.">SetPathSector</a> (<span class="keyword">const</span> <span class="keywordtype">char</span> *sectorname) = 0;
<a name="l00369"></a>00369 
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcLinearMovement.html#a676d9e115e54d443adcbed32fd7347a3" title="Check if mesh is on ground.">IsOnGround</a> () <span class="keyword">const</span> = 0;
<a name="l00374"></a>00374 
<a name="l00378"></a>00378   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#a3313a50d38ad9135bc0aea4608ccb313" title="Set mesh onground flag (will assume it is on ground until it moves).">SetOnGround</a> (<span class="keywordtype">bool</span> onground) = 0;
<a name="l00379"></a>00379 
<a name="l00383"></a>00383   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aa0273003a0eb9f30a034fa7a6811ab4f" title="Set if pcmesh should be transformed to follow the contour of the ground.">SetHugGround</a> (<span class="keywordtype">bool</span> hugGround) = 0;
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="comment">/*</span>
<a name="l00386"></a>00386 <span class="comment">   * Set maximum time delta to use when extrapolating positions.</span>
<a name="l00387"></a>00387 <span class="comment">   */</span>
<a name="l00388"></a>00388   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetDeltaLimit (<span class="keywordtype">float</span> deltaLimit) = 0;
<a name="l00389"></a>00389 
<a name="l00391"></a>00391   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcLinearMovement.html#a0dd6f7236857f32afda0559885bd8119" title="Get the delta limit.">GetDeltaLimit</a> () <span class="keyword">const</span> = 0;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">/*</span>
<a name="l00394"></a>00394 <span class="comment">   * Rotates the mesh by a certain amount. This function is intended to be</span>
<a name="l00395"></a>00395 <span class="comment">   * used internally and should not be used.</span>
<a name="l00396"></a>00396 <span class="comment">   */</span> 
<a name="l00397"></a>00397   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> RotateV (<span class="keywordtype">float</span> delta) = 0;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">/*</span>
<a name="l00400"></a>00400 <span class="comment">   * Set value of gravity affecting this object.</span>
<a name="l00401"></a>00401 <span class="comment">   */</span>
<a name="l00402"></a>00402   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetGravity (<span class="keywordtype">float</span> grav) = 0;
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">/*</span>
<a name="l00405"></a>00405 <span class="comment">   * Get current value of gravity affecting this object.</span>
<a name="l00406"></a>00406 <span class="comment">   */</span>
<a name="l00407"></a>00407   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetGravity () = 0;
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   <span class="comment">/*</span>
<a name="l00410"></a>00410 <span class="comment">   * Reset gravity to default (19.6f) for this object.</span>
<a name="l00411"></a>00411 <span class="comment">   */</span>
<a name="l00412"></a>00412   <span class="keyword">virtual</span> <span class="keywordtype">void</span> ResetGravity () = 0;
<a name="l00413"></a>00413 
<a name="l00420"></a>00420   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ad3277adf4f3f41f2b0723b05ca7be340" title="Shedules a callback when gravity has grasped an object and is dragging it down.">AddGravityCallback</a> (<a class="code" href="structiPcGravityCallback.html" title="Inherit this class if you want to know when gravity is applied to a certain iPcLinearMovement.">iPcGravityCallback</a>* callback) = 0;
<a name="l00421"></a>00421 
<a name="l00425"></a>00425   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#abc5860587b113c8cb3dabf50e25f20f8" title="Remove a gravity callback.">RemoveGravityCallback</a> (<a class="code" href="structiPcGravityCallback.html" title="Inherit this class if you want to know when gravity is applied to a certain iPcLinearMovement.">iPcGravityCallback</a>* callback) = 0;
<a name="l00426"></a>00426 
<a name="l00428"></a>00428   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcLinearMovement.html#a437c8c531eab184fd8c62f61dc705d30" title="Get the total displacement caused by space warping portals.">GetPortalDisplacement</a> () = 0;
<a name="l00429"></a>00429 
<a name="l00431"></a>00431   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#acd5fa1510e1363a67baaaff4dd4c8013" title="Clear the total displacement caused by space warping portals.">ClearPortalDisplacement</a> () = 0;
<a name="l00432"></a>00432 
<a name="l00438"></a>00438   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#ac2e794bf145fbd5230bc731d0a3bc8e1" title="Set full position and sector.">SetFullPosition</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* center_name, <span class="keywordtype">float</span> yrot,
<a name="l00439"></a>00439         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00444"></a>00444   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcLinearMovement.html#aa665242aafa97f3204e4118595c93442" title="Set position and sector.">SetPosition</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* center_name, <span class="keywordtype">float</span> yrot,
<a name="l00445"></a>00445         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00446"></a>00446 };
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="preprocessor">#endif</span>
<a name="l00449"></a>00449 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
